#if !defined( __GROUPS_H )
#define __GROUPSS_H

#include <list>

#include "defs.h"

class ografo;
class ostream;

class relazione {
  std::vector<int> rel;
 public:
  relazione():rel(0) {}
  relazione(std::vector<int>& vec):rel(vec) {}

	int get_rel(int i) const {return rel[i];}
	const std::vector<int>& get_rel() const {return rel;}
	void set_rel(int i, int j) {rel[i]=j;}
	void push_back(int j) {rel.push_back(j);}
	void pop_back() {rel.pop_back();}
	
  void cancella_coppie_opposte();
	void inverti();
	void ruota(int);
	void permuta(int, int);
	void sostituisci(int, const std::vector<int>&);

  int ciclo() const;
  bool commutatore() const;
  int esplicita() const;
	int count(int i) const;
	int lung() const;
	
  void forma_standard();
};

class gruppo_abeliano;

class gruppo {
  int generatori;
  std::list<relazione> relazioni;
 public:
  gruppo(int g=0):generatori(g), relazioni(0) {}

	bool semplifica_con_sostituzioni(int);
	bool semplifica_con_sostituzioni();
	bool semplifica_abbinando_cicli();
	bool semplifica_cambiando_generatori();
	gruppo& semplifica();
  gruppo& forma_standard();

  void scrivi(std::ostream& = std::cout) const;

  gruppo& permuta(int, int);
	gruppo& cambia_generatore(int, int);

	int num_generatori() const {return generatori;}
  int num_relazioni() const;
	int lung() const;
  bool forma_abeliana() const;
  bool libero(int) const;

	friend gruppo pi(const ografo&);
	friend gruppo_abeliano abelianizzato(const gruppo&);
};

class gruppo_abeliano {
	std::vector<int> p;
 public:
  gruppo_abeliano():p(0) {}
	gruppo_abeliano(std::vector<int>& v):p(v) {}

  void scrivi(std::ostream& = std::cout) const;

  void forma_canonica();

	friend bool operator==(const gruppo_abeliano&, const gruppo_abeliano&);
	friend gruppo_abeliano abelianizzato(const gruppo&);
};

gruppo pi(const ografo&);
gruppo_abeliano abelianizzato(const gruppo&);

#endif
