#include <stdlib.h>
#include <math.h>            
#include <string.h>
#include <iostream>
#include <iomanip>
#include <list>
#include <vector>
#include <algorithm>

#include "defs.h"
#include "math.h"
#include "string.h"
#include "faces.h"
#include "ograph.h"
#include "surfaces.h"

superficie TORO = superficie(0,1);
superficie SFERA = superficie(2,1);
superficie TORO2 = superficie(-2,1);
superficie TORO3 = superficie(-4,1);

vertice3::vertice3() {
  for(int t=0; t<3; t++) {vicino[t]=0;col[t]=0;tor[t]=0;}
}

//crea grafo3 formata dalle facce in o.ff avente colore 1 (deve essere un ciclo in H_2(Z_2))
grafo3 grafo3_di_superficie_da_colori_facce(ografo o, bool con_cicli) {
  grafo3 s;
  const std::vector<faccia>& ff = o.get_ff();
  for (int i=0; i<ff.size(); i++) s.colori.push_back(ff[i].get_colore() % 2);
  int l=o.lung();
  tensor2 w(2*l, std::vector<int>(4,0));
  std::vector<tetraedro> tetra; for (int i=0; i<l; i++) tetra.push_back(tetraedro(ff, i) % 2);
  std::vector<teta> th = get_teta(o, FALSE);
  for (int i=0; i<2*l; i++) th[i] = th[i] % 2;
  int critico[4]; int colcritico[4]; 
  tensor3 cic(4, tensor2(2*l, std::vector<int>(4,0)));
  if (con_cicli) {
    int quanti=0;
    for (int i=0; i<l && quanti<3; i++) {
      for (int j=0; j<4; j++) if (o.get_v(i,j)>i && th[o.v2spigolo(i,j)].nullo()) {
        critico[quanti]=i; colcritico[quanti]=j;
        critico[++quanti]=o.get_v(i,j); colcritico[quanti++]=o.get_col(i,j);
      }
    }
    ordina_da_spigolo(ff, critico[0], colcritico[0]);
    int orientazione[3];
    for (int i=0; i<ff.size(); i++) if (!ff[i].get_colore()) {	  //disegna cicli
      orientazione[i] = (ff[i].get_passaggio(1)==critico[1]);
      bool componente = 0;
      for (int j=0; j<ff[i].lati(); j++) {
        int vt=ff[i].get_passaggio(j);
        int col=ff[i].get_uscita(j);
        if (!th[o.v2spigolo(vt,col)].nullo()) {
          if (i<=1) {
            bool sign = (orientazione[i]+componente+i) % 2;
            cic[2*componente][vt][col]+=(1-2*sign);
            cic[2*componente][o.get_v(vt,col)][o.get_col(vt,col)]+=(2*sign-1);
          }
          if (i>=1) {
            bool sign = (orientazione[i]+componente+i+1) % 2;
            cic[2*componente+1][vt][col]+=(1-2*sign);
            cic[2*componente+1][o.get_v(vt,col)][o.get_col(vt,col)]+=(2*sign-1);
          }
        }
        else componente=1-componente;
      }
    }
    bool finito = FALSE; int num_faccia=2;
    do {                             //aggiungi 2-bordi sulle facce che collassano
      finito = TRUE;
      for (int i=0; i<ff.size(); i++) {
        const faccia& f = ff[i];
        int cc[4];
        if (f.get_colore()==num_faccia) {
          bool trovo=0;
          for (int j=0; j<f.lati() && !trovo; j++) {
            int vt=f.get_passaggio(j);
            int col=f.get_uscita(j);
            if (th[o.v2spigolo(vt,col)].nullo() && !th[o.v2spigolo(vt,col)].nullo()) {
              trovo = TRUE;
              for (int t=0; t<4; t++) cc[t]=cic[t][vt][col];
            }
          }
          for (int j=0; j<f.lati(); i++) {
            int vt=f.get_passaggio(j);
            int col=f.get_uscita(j);
            for (int t=0; t<4; t++) {
              cic[t][vt][col]-=cc[t];
              cic[t][o.get_v(vt,col)][o.get_col(vt,col)]+=cc[t];
            }
          }
          finito = FALSE; num_faccia+=2;
        }
      }
    } while (!finito);
  }
  for (int i=0; i<l; i++) {  //vertici: sdoppia o cancella
    o.v.push_back(0);
    switch (tetra[i].somma()) {
      case 0: break;
      case 4: 
        o.v[l+i] = new overtice();
        for (int j=0; j<=1; j++) {
          int vic = (o.get_v(i,j+2)==i && o.get_col(i,j+2)>=2) ? l+i : o.get_v(i,j+2);
          o.set_col(l+i,j+2,vic,o.get_col(i,j+2),o.get_tor(i,j+2));
          if (o.get_v(i,j) == i && o.get_col(i,j) >=2)
            o.v[i]->set_vicino(j,l+i);
          if (con_cicli)
            for (int c=0; c<4; c++)
              cic[c][l+i][j+2] = cic[c][i][j+2];
        }
        o.set_col(i,2,l+i,0,0);
        o.v[i]->set_vicino(3,-1); w[i][2]=1; w[i][3]=1;
        o.v[l+i]->set_vicino(1,-1); w[l+i][0]=1; w[l+i][1]=1;
        if (con_cicli)
          for (int c=0; c<4; c++) {
            cic[c][i][2] = -(cic[c][i][0]+cic[c][i][1]);
            cic[c][l+i][0] = -cic[c][i][2];
          }
        /* secondo me non serve piu', ora che ci sono i set_col sopra
        for (int j=0; j<l+i; j++) {
          if (o.v[j]) {
            for (int k=0; k<4; k++) {
              if (o.get_v(j,k) == i && o.get_col(j,k)>=2)
                o.v[j].set_vicino(k, l+i);
            }
          }
          }*/
    }
  }
  for (int i=0; i<2*l; i++) { //spigoli: cancella o torsione
    if (o.v[i]) {
      for (int n=0; n<4; n++) {
        teta tk = th[o.v2spigolo(i % l,n)];
        if (i<l && tetra[i].somma() == 3 && tk.nullo()) o.v[i]->set_vicino(n,-1);
        else if (!w[i][n]) {
          int tr = o.get_tor(i,n).get_t(); int n2 = o.get_col(i,n);
          int j = o.get_v(i,n); int torfinale = 0;
          int manca=0;
          while (manca<3 && (tk.get_elem(manca))) manca++;
          if (n % 2 == n2 % 2) {
            if (n % 2) manca = 2-manca;
            if ((tr == 1 && manca != 2) || (tr == 2 && manca != 0)) torfinale=1;
          }
          else {
            int pippo = (3-2*tr) * (2*(n % 2)-1);
            if ((!tr) || (pippo == 1 && manca == 0) || (pippo == -1 && manca == 2))
              torfinale = 1;
          }
          o.set_tor(i,n,torfinale);
          w[i][n]=1; w[j][n2]=1;
        }
      }
    }
  }
  for (int i=0; i<l; i++) { //ultime mosse sui vertici tipo 4
    if (tetra[i].somma() == 4) {
      int elvuoto=0;
      while (elvuoto<3 && tetra[i].get_elem(elvuoto)) elvuoto++;
      int c=0;
      switch (elvuoto) {
        case 1:
          o.set_col(i,3,o.get_v(l+i,3),o.get_col(l+i,3),o.get_tor(l+i,3));
          o.v[l+i]->set_vicino(3,-1);
          o.set_col(l+i,1,o.get_v(i,1),o.get_col(i,1),o.get_tor(i,1));
          o.v[i]->set_vicino(1,-1);
          if (con_cicli) for (c=0; c<4; c++) {
            cic[c][i][3] = cic[c][l+i][3];
            cic[c][l+i][1] = cic[c][i][1];
            cic[c][i][2] = -(cic[c][i][0]+cic[c][i][3]);
            cic[c][l+i][0] = -(cic[c][l+i][1]+cic[c][l+i][2]);
          }
        case 0: o.set_tor(i,2,1);
      }
    }
  }
  for (int i=0; i<2*l; i++) { //sposta i vertici in modo 0,1,2
    if (o.v[i]) {
      for (int j=0; j<3; j++) {
        if (o.get_v(i,j)==-1) {
          for (int k=j+1; k<4; k++) {
            o.set_col(i,k-1,o.get_v(i,k),o.get_col(i,k),o.get_tor(i,k));
            if (con_cicli) for (int c=0; c<4; c++)
              cic[c][i][k-1]=cic[c][i][k];
          }
          o.v[i]->set_vicino(3,-1);
        }
      }
    }
  }
  for (int i=0; i<2*l; i++) { //tappabuchi
    if (!o.v[i]) {
      int j=i+1;
      while (j<2*l && !o.v[j]) j++;
      if (j<2*l) {
        o.v[i] = new vertice();
        for (int k=0; k<3; k++) {
          int vic = (o.get_v(j,k)!=j) ? o.get_v(j,k):i;
          o.set_col(i,k,vic,o.get_col(j,k),o.get_tor(j,k));
          if (con_cicli) for (int c=0; c<4; c++)
            cic[c][i][k]=cic[c][j][k];
        }
        delete o.v[j]; o.v[j]=0;
      }
    }
  }				//crea, finalmente
  for (int i=0; i<2*l ; i++) s.v.push_back(vertice3());
  for (int i=0; i<2*l ; i++)
    for (int j=0; j<3; j++) {
      s.set_col(i,j,o.get_v(i,j),o.get_col(i,j),o.get_tor(i,j).get_t());
      if (con_cicli) for (int c=0; c<4; c++)
        s.ciclo[c][i][j]=cic[c][i][j];
    }
  return s;
}

//crea grafo3 di bordo determinato dall'o-grafo 'o'
//funziona solo se non ci sono spigoli falsi!
//          1
//        0   2
//
//     2         1
//   0             0
//     1         2
//
//        2   0
//          1
//queste sono le uscite nel grafo3 intorno ad un vertice dell'ografo
//
grafo3 grafo3_di_bordo(const ografo& o) {
  grafo3 s;
  int l=o.lung();
  for (int i=0; i<4*l; i++) s.v.push_back(vertice3());
  for (int i=0; i<l; i++) {
    for (int j=0; j<4; j++) {
      for (int k=0; k<3; k++) {
        int i2 = o.get_v(i,j);
        int ingresso = 0; 
				torsione tr = o.get_tor(i,j); 
				int cl = o.get_col(i,j);
        if (j % 2 == cl % 2) {
          if (j % 2) tr.invert();
          ingresso = (3+2-k-tr.get_t()) % 3;
        }
        else {
          if (!tr.get_t()) ingresso = k;
          else {
            int fisso=2*(tr.get_t()==2); 
						if (j % 2) fisso = 2 - fisso;
            ingresso = 2-k;
            if (fisso!=(2-k))
              for (int y=0; y<3; y++)
                if (y!=fisso && y!=(2-k)) ingresso = y;
          }
        }
        int j2=(cl+3+ingresso) % 4;
        s.set_col(4*i+((j+k+3) % 4), 2-k, 4*i2+j2, 2-ingresso, 0);
      }
    }
  }
  for (int i=0; i<4*l; i+=2) {
    if (s.get_v(i,0) != i || s.get_col(i,0) != 1) {
      int etemp = s.get_v(i,0); int ctemp = s.get_col(i,0);
      s.set_col(i,0,s.get_v(i,1),s.get_col(i,1));
      s.set_col(i,1,etemp,ctemp);
    }
  }
  return s;
}

//collega i vertici i e j con uscite i2 e j2
void grafo3::set_col(int i, int j, int i2, int j2, int tr) {
  v[i].set_vicino(j,i2);
  v[i2].set_vicino(j2,i);
  v[i].set_col(j,j2);
  v[i2].set_col(j2,j);
	set_tor(i,j,tr);
}

//assegna la torsione tr al vertice (i,j)
void grafo3::set_tor(int i, int j, bool tr) {
  v[i].set_tor(j,tr); v[get_v(i,j)].set_tor(get_col(i,j),tr);
}

//crea le facce. ATTENZIONE: funziona solo se le torsioni sono tutte zero.
std::vector<faccia_grafo3> facce_grafo3 (const grafo3& s) {
  tensor2 w(s.lung(), std::vector<int>(3,0));
  std::vector<faccia_grafo3> fs(0);
  for (int i=0; i<s.lung(); i++)
    for (int j=0; j<3; j++)
      if (!w[i][j]) {
        fs.push_back(faccia_grafo3());
        faccia_grafo3& f = fs.back();
        w[i][j]=1;
        f.passaggio.push_back(i);
        f.uscita.push_back(j);
        f.entrata.push_back((j-1) % 3);
        int n=0;
        do {
          n++;
          f.passaggio.push_back(s.get_v(f.get_passaggio(n-1), f.get_uscita(n-1)));
          f.entrata.push_back(s.get_col(f.get_passaggio(n-1), f.get_uscita(n-1)));
          f.uscita.push_back((f.get_entrata(n)+1) % 3);
          w[f.get_passaggio(n)][f.get_uscita(n)]=1;
        } while (f.get_passaggio(n)!=f.get_passaggio(0) || f.get_uscita(n)!=f.get_uscita(0));
        f.passaggio.pop_back();
        f.entrata.pop_back();
        f.uscita.pop_back();
      }
  return fs;
}

superficie bordo(const ografo& o) {
  return superficie(grafo3_di_bordo(o),1);
}

superficie superficie_da_colori_facce(const ografo& o) {
  return superficie(grafo3_di_superficie_da_colori_facce(o),0);
}

void uffa (const ografo& o, int num_faccia, std::list<grafo3>& ls);

std::list<grafo3> grafi3_di_superfici_contenute (const ografo& o) {
  std::list<grafo3> sl(0);
  for (int i=0; i<o.get_ff().size(); i++)
    o.get_ff()[i].set_colore(-1);
  uffa(o, 0, sl);
  return sl;
}

std::list<superficie> superfici_contenute (const ografo& o) {
  return superfici(grafi3_di_superfici_contenute(o));
}

int superficie::get_eulero(int i) const {
	if (i>=0) return eulero[i];
  int e=0; 
  for (int j=0; j<eulero.size(); j++) e+=eulero[j];
  return e;
}

bool superficie::get_orientabile(int i) const {
	if (i>=0) return orientabile[i];
  for (int j=0; j<orientabile.size(); j++) 
    if (!orientabile[i]) return FALSE; 
  return TRUE;
}

void grafo3::set_facce() {
  ff = facce_grafo3(*this);
}

// dice se (vert,usc)<(vert',usc') lessicografico, ove vert',usc' determina lo stesso spigolo.
bool grafo3::prima_occorrenza_spigolo(int vert, int usc) const {
  return (get_v(vert, usc) > vert || 
          (get_v(vert, usc)==vert && get_col(vert,usc)>usc));
}

void uffa (const ografo& o, int num_faccia, std::list<grafo3>& ls) {
  //si perde molto tempo se non si tagliano i rami secchi ?
  //Ho commentato la routine. Non funziona th = ...
  //deve prendere i valori assoluti dei colori, lasciando i -1 come sono.
  if (num_faccia<o.get_ff().size()) {
    /*
    for (int j=0; j<o.lung(); j++)
      for (int k=0; k<4; k++)
        if (o.prima_occorrenza_spigolo(j,k)) {
          teta th = abs(teta(o.get_ff(), j, k));
          if (th.get_elem(0)>=0 && th.get_elem(1)>=0 && th.get_elem(2)>=0 && !th.ammissibile()) {
            o.get_ff()[num_faccia].set_colore(-1); return;
          }
          }*/
    for (int i=0; i<=1; i++) {
      o.get_ff()[num_faccia].set_colore(i);
      uffa (o, num_faccia+1, ls);
    }
    o.get_ff()[num_faccia].set_colore(-1);
  }
  else if (o.colori_facce_ammissibili()) {
    bool trovato=FALSE;
    for (int i=0; i< o.get_ff().size(); i++)
      if (o.get_ff()[i].get_colore()) trovato=TRUE;		//non deve essere vuota
    if (trovato) {
      ls.push_back(grafo3_di_superficie_da_colori_facce(o));
    }
  }
}

//restituisce ris[][], ove ris[vert][j]=k se e solo se la k-esima (partendo da 1)
//componente di bordo e' adiacente a 'vert' sull'uscita 'j'.
tensor2 adiacenze_bordo_su_vertice(const ografo& o) {
	grafo3 g = grafo3_di_bordo(o);
	std::vector<int> cc = g.vertici_in_componenti_connesse();
	tensor2 ris = tensor2(o.lung(), std::vector<int>(4,0));
	for (int i=0; i<o.lung(); i++)
		for (int j=0; j<4; j++)
			ris[i][j] = cc[4*i+j];
	return ris;
}

//restituisce un vettore cc[], tale che il vertice 'vert' sta sulla
//componente connessa c[vert]-esima (partendo da 1) del grafo3.
std::vector<int> grafo3::vertici_in_componenti_connesse() const {
	int l=lung();
  std::vector<int> cc(l,0);
	int contatore = 1; 
  for (int t=0; t<l; t++) {
    if (!cc[t]) cc[t] = contatore++;
    for (int r=0; r<3; r++) {
      int colore = cc[get_v(t,r)];
      if (colore != cc[t]) {
        if (!colore) cc[get_v(t,r)] = cc[t];
        else replace(cc.begin(), cc.end(), colore, cc[t]);
      }
    }
  }
	//tappabuchi:
  std::vector<int> w(l,0);
  for (int t=0; t<l; t++) w[cc[t]] = 1;
  for (int j=contatore-1; j>0; j--) if (!w[j])
    for (int t=0; t<l; t++) if (cc[t]>j) cc[t]--;
	return cc;
}

//Restituisce la superficie del grafo3 s. Se tuttozero == TRUE, allora parte
//dal presupposto che le torsioni sono tutte zero (quindi la grafo3 e'
//orientata)
superficie::superficie(const grafo3& s, int tuttozero) {
  colore = s.get_colori();
  int l = s.lung();
	std::vector<int> cc = s.vertici_in_componenti_connesse();
  int cconn = 0; for (int t=0; t<l; t++) if (cc[t]>cconn) cconn=cc[t];
  tensor2 w1(l, std::vector<int>(3,0));
  for (int contatore = 1; contatore<=cconn; contatore++) {
    int facce = 0; int vertici = 0;
    for (int i=0; i<l; i++) if (cc[i] == contatore) {
      vertici++;
      for (int j=0; j<3; j++) {
        if (!w1[i][j]) {
          facce++; int destra=0;
          w1[i][j]=1; int i2=i; int j2=j; int cappio=0;
          while (!cappio) {
            destra = (destra + s.get_tor(i2,j2)) % 2;
            int old_i2 = i2;
            i2 = s.get_v(i2,j2);
            j2 = (s.get_col(old_i2,j2) + 1 + destra) % 3; 
            w1[i2][(j2+destra) % 3] = 1;
            if (i2==i && j2==j && !destra) cappio=1;
          }
        }
      }
    }
    int tot = abs(facce-vertici/2) % 2;
    if (!tuttozero && !tot && ((facce - vertici/2) < 2)) {
      tensor2 unnesiste(l,std::vector<int>(3,0));
      for (int i=0; i<l && !tot; i++) if (cc[i] == contatore) {
        std::vector<int> wu(l,-1); std::vector<int> tt(l,0);
        tot = 0; 
        tensor2 ww(l, std::vector<int>(3,0));
        int icorr = i;
        int uscita=0;
        while (uscita<3 && unnesiste[i][uscita]) uscita++;
        int cappio = 0; int entrata = 0;
        if (uscita!=3) {
          while (!cappio) {
            tt[icorr] = tot;
            wu[icorr] = s.get_tor(icorr,uscita); ww[icorr][uscita] = 1;
            tot+= s.get_tor(icorr,uscita);
            entrata = s.get_col(icorr,uscita);
            icorr = s.get_v(icorr, uscita);
            for (uscita=0; uscita<3 && (unnesiste[icorr][uscita] || uscita==entrata); uscita++) {}
            if (wu[icorr]>=0) cappio=1;
          }
          int omotopia=1; uscita = entrata; tot-=tt[icorr];
          while (omotopia) {
            unnesiste[icorr][uscita]=1; unnesiste[s.get_v(icorr,uscita)][s.get_col(icorr,uscita)]=1;
            icorr = s.get_v(icorr,uscita);
            int nonesiste=0;
            for (int k=0; k<3; k++) {
              if (unnesiste[icorr][k]) nonesiste++;
              else if (!ww[icorr][k]) uscita = k;
            }
            if (nonesiste!=2) omotopia=0;
          }
        }
        tot = tot % 2;
        int y=0;
        while (y<3 && unnesiste[i][y]) y++;
        if (y<3) i--;
      }
    }
    eulero.push_back(facce - vertici/2);
		orientabile.push_back(!tot);
		colore.push_back(0);
  }
}

std::list<superficie> superfici(const std::list<grafo3>& sl) {
  std::list<superficie> gl;
  std::list<grafo3>::const_iterator s = sl.begin();
  while (s!=sl.end())
    gl.push_back(superficie(*(s++),0));
  return gl;
}

void superficie::scrivi(std::ostream& f) const {
  for (int i=0; i<componenti_connesse(); i++) {
		if (orientabile[i]) {
			(eulero[i] == 2) ? f << "S" : f << "T";
			f << "^(" << (2-eulero[i])/2 + 2*(eulero[i]==2);
		}
		else f << "U^(" << 2-eulero[i];
		f << ") ";
	}
  f << "\n";
}

void grafo3::scrivi_facce(std::ostream& f) const {
  for (int i = 0; i<ff.size(); i++)
    f << ff[i].lati() << " ";
	f << "\n";
}

bool operator==(const superficie& x, const superficie& y) {
	int lx = x.componenti_connesse();
	int ly = y.componenti_connesse();
	if (lx!=ly) return FALSE;
	std::vector<bool> flag(lx,0);
	for (int i=0; i<lx; i++) {
		bool trovato = FALSE;
		for (int j=0; j<ly && !trovato; j++)
			if (!flag[j] && x.eulero[i]==y.eulero[j] && x.orientabile[i]==y.orientabile[j]) {
				trovato = TRUE;
				flag[j] = TRUE;
			}
		if (!trovato) return FALSE;
	}
	return TRUE;
}

/*
void grafo3::scrivi(ostream* f) {
  double matr[MAX][4][3];
  int label[MAX][4][3];
  getL(matr,label);
  *f << "Lunghezze degli spigoli nel bordo :\n";
  for (int t=0; v[4*t]; t++) {
    *f << "N. " << setw(2) << t << ":  ";
    for (int c=0; c<4; c++) {
      for (int j=0; j<3; j++)
        *f << setw(8) << matr[t][c][j] << " [" << setw(2) << label[t][c][j] << "] ";
      if (c==1) *f << "\n        ";
      if (!mod(c,2)) *f << " | ";
    }
    *f << "\n";
  }
}

//mette su matr[v][i][j] la lunghezza dello spigolo (orientato!) uscente dal vertice
//i-esimo associato al vertice v-esimo dell'ografo, con uscita 0<=j<3 
//inoltre, accoppia in label (con coppie di interi crescenti) gli spigoli coincidenti
void grafo3::getL(double matr[][4][3], int label[][4][3]) {
  int lb=1;
  for (int i=0; v[i]; i++) {
    vertice3* v3 = v[i];
    int v = v3->tvertice_origine->etic;
    int c = v3->col_origine;
    for (int j=0; j<3; j++) {
      double L = v3->L(j);
      matr[v][c][j] = L;
      int i2 = v3->vicino[j]->etic;
      int j2 = v3->col[j];
      if (i<i2 || (i==i2 && j<j2)) {
        label[v][c][j] = lb;
        label[v3->vicino[j]->tvertice_origine->etic][v3->vicino[j]->col_origine][j2] = lb++;
      }
    }
  }
}
*/

/* a chesserve ?
void grafo3::semplifica() {
  //supppongo sia un toro
  int l=lung();
  if (l>2) {
    int w[2*MAX][3]; for (int i=0; v[i]; i++) for (int j=0; j<3; j++) w[i][j]=0;
    int vert=0; int usc=0; bool destra=0;
    bool tornato = FALSE;
    while (!tornato) {
      w[vert][usc]++; w[v[vert]->vicino[usc]->etic][v[vert]->col[usc]]++;
      if (v[vert]->tor[usc]) destra=1-destra;
      int ent=v[vert]->col[usc];
      vert = v[vert]->vicino[usc]->etic;
      usc = mod(ent+1+destra,3);
      if (vert==0 && usc==0) tornato = TRUE;
    }
    bool trovato=FALSE;
    for (int i=0; !trovato; i++)
      for (int j=0; j<3 && !trovato; j++)
        if (w[i][j]==1) {
          trovato = TRUE; int vert2=i; int usc2=j;
          bool torno = FALSE; bool destra=0;
          while (!torno) {	//aggiungi 2-bordo
            if (v[vert2]->tor[usc2]) destra=1-destra;
            int ent2=v[vert2]->col[usc2];
            vert2 = v[vert2]->vicino[usc2]->etic;
            usc2 = mod(ent2+1+destra,3);
            for (int c=0; c<4; c++) {
              ciclo[c][vert2][usc2]-=ciclo[c][i][j];
              ciclo[c][v[vert2]->vicino[usc2]->etic][v[vert2]->col[usc2]]+=ciclo[c][i][j];
            }
            if (vert2==i && usc2==j) torno = TRUE;
          }
          int ii[2]; ii[0]=i; ii[1]=v[i]->vicino[j]->etic;
          int jj[2][3]; jj[0][0]=mod(j+1,3); jj[1][0]=mod(v[i]->col[j]+1,3);
          for (int t=0; t<2; t++) jj[t][1]=mod(jj[t][0]+1,3);
          int col[2][2]; for (int t=0; t<2; t++) for (int t2=0; t2<2; t2++) col[t][t2]=v[ii[t]]->col[jj[t][t2]];
          if (ii[0]==ii[1])	{		//loop su stesso vertice
            int i0 = (v[ii[0]]->vicino[jj[0][1]]!=v[ii[0]]);
            int k[2]; for (int t=0; t<2; t++) k[t] = mod(col[0][i0]+1+t,3);
            int t= 2;      //AGGIUNTA ORA QUESTA RIGA. Problema qui da vedere.
            int vert = v[ii[0]]->vicino[jj[0][i0]]->etic;
            int tor = v[vert]->tor[k[t]] + v[vert]->tor[k[1-t]];
            for (int t=0; t<2; t++) {
              v[vert]->vicino[k[t]]->vicino[v[vert]->col[k[t]]] = v[vert]->vicino[k[1-t]];
              v[vert]->vicino[k[t]]->col[v[vert]->col[k[t]]] = v[vert]->col[k[1-t]];
              v[vert]->vicino[k[t]]->tor[v[vert]->col[k[t]]] = tor;
            }
          }
          else {					//caso tipico
            if (v[ii[0]]->vicino[jj[0][0]]!=v[ii[1]] && v[ii[0]]->vicino[jj[0][1]]!=v[ii[1]])
              for (int t=0; t<2; t++) {
                int tor=mod(v[ii[t]]->tor[jj[t][0]] + v[ii[t]]->tor[jj[t][1]],2);
                for (int t2=0; t2<2; t2++) {
                  v[ii[t]]->vicino[jj[t][t2]]->vicino[col[t][t2]] = v[ii[t]]->vicino[jj[t][1-t2]];
                  v[ii[t]]->vicino[jj[t][t2]]->col[col[t][t2]] = col[t][1-t2];
                  v[ii[t]]->vicino[jj[t][t2]]->tor[col[t][t2]] = tor;
                }
              }
            else {	//i due vertici sono collegati due volte
              int k[2]; for (int t=0; t<2; t++) k[t] = (v[ii[t]]->vicino[jj[t][1]]==v[ii[1-t]]);
              int tor = mod(v[ii[0]]->tor[jj[0][0]] + v[ii[0]]->tor[jj[0][1]] + v[ii[1]]->tor[jj[1][1-k[1]]],2);
              for (int t=0; t<2; t++) {
                v[ii[t]]->vicino[jj[t][1-k[t]]]->vicino[col[t][1-k[t]]]=v[ii[1-t]]->vicino[jj[1-t][1-k[1-t]]];
                v[ii[t]]->vicino[jj[t][1-k[t]]]->col[col[t][1-k[t]]] = col[1-t][1-k[1-t]];
                v[ii[t]]->vicino[jj[t][1-k[t]]]->tor[col[t][1-k[t]]] = tor;
              }
            }
            for (int t=0; t<2; t++) {
              delete v[ii[t]]; v[ii[t]]=0;
            }
          }
          for (int i=0; i<=l; i++)  		//tappabuchi
            if (!v[i]) {
              int j=i+1;
              for (; j<l && !v[j]; j++) {}
              if (j<l) {
                v[i]=v[j]; v[j]=0;
                v[i]->etic = i;
                for (int c=0; c<4; c++)
                  for (int k=0; k<3; k++)
                    ciclo[c][i][k]=ciclo[c][j][k];
              }
            }
          semplifica();
        }
  }
}

tensor2 matrice(const grafo3& s) {
  tensor2 h(0);
  int k[2][2];
  for (int t=0; t<2; t++) for (int t2=0; t2<2; t2++) {h[t][t2]=ciclo[t][0][t2]; k[t][t2]=ciclo[2+t][0][t2];}
  while (k[0][0]*k[0][1]) {
    int max = (abs(k[0][1])>=abs(k[0][0]));
    int sign = (k[0][0]*k[0][1]<0);
    for (int t=0; t<2; t++) {
      k[t][max]-=k[t][1-max]*(1-2*sign);
      h[t][max]-=h[t][1-max]*(1-2*sign);
    }
  }
  if (!k[0][0]) for (int t=0; t<2; t++) {
    int temp=k[t][0]; k[t][0]=k[t][1]; k[t][1]=temp; temp=h[t][0]; h[t][0]=h[t][1]; h[t][1]=temp;
  }
  if (k[1][0]) {
    bool sign = (k[1][0]*k[1][1]>0);
    h[1][0]+=abs(k[1][0])*h[1][1]*(1-2*sign);
    h[0][0]+=abs(k[1][0])*h[0][1]*(1-2*sign);
    k[1][0]=0;
  }
  for (int t=0; t<2; t++)
    if (k[t][t]==-1) {
      for (int t2=0; t2<2; t2++)
        h[t2][t]*=-1;
      k[t][t]=-1;
    }
}
*/
